import { OverviewImageLink } from '@/types/models';
import { OverviewImageLinkConfigSize } from '../OverviewImageModal.types';

export const getOverviewImageLinkSize = (
  { polygon }: OverviewImageLink,
  {
    sizeFactor,
  }: {
    sizeFactor: number;
  },
): OverviewImageLinkConfigSize => {
  const polygonScaled = polygon.map(({ x, y }) => ({ x: x * sizeFactor, y: y * sizeFactor }));
  const [pointTopLeft, , pointBottomRight] = polygonScaled;
  const width = pointBottomRight.x - pointTopLeft.x;
  const height = pointBottomRight.y - pointTopLeft.y;
  const { x, y } = pointTopLeft;

  return {
    top: y,
    left: x,
    width,
    height,
  };
};
